{% extends '@!EasyAdmin/crud/detail.html.twig' %}

{% block detail_fields %}
  {{ parent() }}

  {% set logs = getLogsForEntity(entity.instance) %}
  {% if logs %}
    <hr/>

    <div class="content-header-title">
      <h2 class="title">Logs</h2>
    </div>

    <table class="table">
      <thead>
      <tr>
        <th>Date</th>
        <th>Type</th>
        <th>Changement</th>
        <th>Responsable</th>
      </tr>
      </thead>
      <tbody>
      {% for log in logs %}
        <tr>
          <td>{{ log.timestamp|date('d/m/Y H:i:s') }}</td>
          <td>{{ _self.render_type(log) }}</td>
          <td>{{ _self.render_changes(log) }}</td>
          <td><a href="{{ ea_url()
              .setController('App\\Controller\\Admin\\UserCrudController')
              .setAction('detail')
              .setEntityId(log.userIdentifier) }}">{{ log.userIdentifier }}</a></td>
        </tr>
      {% endfor %}
      </tbody>
    </table>
  {% endif %}

{% endblock %}

{% macro render_changes(log) %}
  {% if not log.changesObject.data %}
    Format de données invalide
  {% else %}
    {% set data = log.changesObject.data %}
    {% if log.type is same as 'workflow_transition' %}
      Workflow "{{ data.workflow }}": transitioned from "{{ data.from }}" to "{{ data.to }}" via "{{ data.transition }}"
    {% elseif log.type is same as 'workflow_denied' %}
      Workflow "{{ data.workflow }}": try to make transition from "{{ data.from }}" to "{{ data.to }}" via "{{ data.transition }}"
    {% elseif log.type is same as 'entity_update' %}
      Champs modifiés : <span class="badge badge-secondary">{{ data.changes.fields_changed|join('</span>,<span class="badge badge-secondary">')|raw }}</span>
    {% elseif log.type is same as 'user_connected' %}
      {% if data.mode is defined %}
        <span class="badge badge-secondary">{{ "connexionmode.#{data.mode}"|trans }}</span>
      {% else %}
        -
      {% endif %}
    {% elseif log.type is same as 'user_connection_failed' %}
      Login : {{ data.login }}
    {% else %}
      <pre>{{ log.changesObject.data|json_encode }}</pre>
    {% endif %}
  {% endif %}
{% endmacro %}

{% macro render_type(log) %}

  {% if not log.isConsistent %}
    <span class="badge badge-danger">Inconsistent ({{ log.type }})</span>
  {% elseif log.type is same as 'workflow_transition' %}
    <span class="badge badge-primary">Workflow transition</span>
  {% elseif log.type is same as 'workflow_denied' %}
    <span class="badge badge-danger">Workflow transition denied</span>
  {% elseif log.type is same as 'entity_update' %}
    <span class="badge badge-info">Mise à jour</span>
  {% elseif log.type is same as 'user_connected' %}
    <span class="badge badge-success">Connexion réussie</span>
  {% elseif log.type is same as 'user_connection_failed' %}
    <span class="badge badge-danger">Connexion échouée</span>
  {% elseif log.type is same as 'entity_create' %}
    <span class="badge badge-success">Création de l'entité</span>
  {% else %}
    <span class="badge badge-secondary">{{ log.type }}</span>
  {% endif %}

{% endmacro %}
